#pragma once

#include "source\binaryfilestream.h"
#include "source\transformations.h"
#include "source\points.h"

// @inv: m_dimensions.x, .y, .z, cannot be negative

enum FITSRESULT
{
	OUTSIDE,
	INTERSECTS,
	CONTAINED
};

#define	PLUSZPLANE	0x001
#define	PLUSYPLANE	0x002
#define	PLUSXPLANE	0x004

class SD3DBox
{
protected:
	Point	m_location;
	Point	m_dimensions;
public:
	SD3DBox(void);
	virtual ~SD3DBox(void);

	// Creates a box centred at location with dimensions dimensions
	void	set(const Point& location, const Point& dimensions )				
	{
		m_location = location;
		m_dimensions = dimensions;
	}
	void	setLocation(const Point& location)
	{
		m_location		= location;		
	}
	void	setDimensions(const Point& dim)
	{
		m_dimensions	= dim;
	}

	void	get(Point* loc, Point* dim)
	{
		*loc = m_location;
		*dim = m_dimensions;
	}

	void		getLocation(Point* loc)		{ *loc = m_location; }
	void		getDimensions(Point* dim)	{ *dim = m_dimensions; }

	FITSRESULT	fits(SD3DBox *pBox);
	int			whichOctants(Point* p, bool* intersections);

};
