#include "sd.h"

SDDetailNode::SDDetailNode(void)
{
	m_pBox = new SD3DBox();

	// Set some default values
	Point loc;
	Point dim;
	loc.x = 0.0;
	loc.y = 0.0;
	loc.z = 0.0;
	dim.x = 1.0;
	dim.y = 1.0;
	dim.z = 1.0;
	m_pBox->set(loc, dim);

}

SDDetailNode::~SDDetailNode(void)
{
	if(m_pBox)
	{
		delete m_pBox;
		m_pBox = NULL;
	}
}

void SDDetailNode::setPosition(Point& p)
{
	// Set the box to the correct position
	m_pBox->setLocation(p);
}

void SDDetailNode::setSize(float size)
{
	Point dim;
	dim.x = size;
	dim.y = size;
	dim.z = size;
	m_pBox->setDimensions(dim);
}

void SDDetailNode::draw()
{
	// Draw a cube at the place of the node
	Point	centre;
	m_pBox->getLocation(&centre);
	Point	dimensions;
	m_pBox->getDimensions(&dimensions);

	glPushMatrix();
	glFrontFace (GL_CW);
	glColor3f (0.03f, 0.53f, 0.96f);
	glTranslated(centre.x, centre.y, centre.z);
	glutSolidCube(dimensions.x);
	glFrontFace (GL_CCW);
	glPopMatrix();
}

FITSRESULT SDDetailNode::fits(SD3DBox* pBox)
{
	return m_pBox->fits(pBox);
}

int SDDetailNode::whichOctants(Point* p, bool* intersections)
{
	return m_pBox->whichOctants(p, intersections);
}

