#include "sd.h"

SDDevsModel::SDDevsModel()
{
}

SDDevsModel::~SDDevsModel()
{
}

bool SDDevsModel::isInputPort(string port)
{
	vector<string>::iterator i = m_inputPorts.begin();
	while(i != m_inputPorts.end() )
	{
		if( (*i) == port)
			return true;
		i++;
	}
	return false;
}

bool SDDevsModel::isOutputPort(string port)
{
	vector<string>::iterator i = m_outputPorts.begin();
	while(i != m_outputPorts.end() )
	{
		if( (*i) == port)
			return true;
		i++;
	}
	return false;
}

// Adds the ports from the model to the ports of this model
int SDDevsModel::addPorts(SDDevsModel* pModel)
{
	int numPortsAdded = 0;

	// This operation can only be done on too models with the same name
	if( pModel->getName() != m_name )
		return numPortsAdded;

	// Search through the models ports to see if there are any new ones
	//*********

	//Add input ports
	vector<string> inputPorts = pModel->getInputPorts();
	vector<string>::iterator i = inputPorts.begin();
	while( i != inputPorts.end() )
	{
		if( !isInputPort( (*i) ) )
		{
			m_inputPorts.push_back( (*i) );
			numPortsAdded++;
		}
		i++;
	}

	//Add output ports
	vector<string> outputPorts = pModel->getOutputPorts();
	i = outputPorts.begin();
	while( i != outputPorts.end() )
	{
		if( !isOutputPort( (*i) ) )
		{
			m_outputPorts.push_back( (*i) );
			numPortsAdded++;
		}
		i++;
	}

	return numPortsAdded;
}

void SDDevsModel::log()
{

	// Log the model values
	::log("Model Data:");

	// Log name
	string s;
	s = "Name: ";	
	s.append(m_name);
	::log(s.c_str());

	// Log state
	s = "State: ";
	char buffer[255];
	sprintf(buffer, "%lf", m_state);
	s.append(buffer);
	::log(s.c_str());

	// Log the input ports
	s = "Input ports: ";
	vector<string>::iterator i = m_inputPorts.begin();
	while(i != m_inputPorts.end())
	{
		s.append((*i));
		s.append(" | ");
		i++;
	}
	::log(s.c_str());

	// Log the output ports
	s = "Output ports: ";
	i = m_outputPorts.begin();
	while(i != m_outputPorts.end())
	{
		s.append((*i));
		s.append(" | ");
		i++;
	}
	::log(s.c_str());

}

