#pragma once

#include <string>
#include <vector>
using namespace std;

class SDSceneNode;
class SLBase;

class SDDevsModel
{
	// Only allow the Simulation Links to modify this classes parameters
	friend class SLLogFile;
	friend class SLMaFile;
	friend class SLPlanFile;

protected:
	SDSceneNode*	m_pSceneNode;

	string			m_name;
	vector<string>	m_outputPorts;
	vector<string>	m_inputPorts;

	double			m_state;

public:
	SDDevsModel();
	virtual ~SDDevsModel();

	virtual string			getName()						{ return m_name; }
	virtual SDSceneNode*	getSceneNode()					{ return m_pSceneNode; }

	virtual vector<string>	getInputPorts()					{ return m_inputPorts; }	
	virtual vector<string>	getOutputPorts()				{ return m_outputPorts; }	
	
	virtual bool			isInputPort(string port);
	virtual bool			isOutputPort(string port);

	// Adds the ports from the model to the ports of this model
	virtual int				addPorts(SDDevsModel* pModel);

	virtual void			log();
};