#pragma once

enum SIMEVENTTYPE
{
	EXTERNAL,
	OUTPUT
};

class SLBase;
class SDTime;

class SDEvent
{	
	friend class SLLogFile;
	friend class SLMaFile;
	friend class SLPlanFile;

protected:
	SDTime			m_time;
	SIMEVENTTYPE	m_type;

	string			m_source;
	string			m_destination;
	string			m_port;
	double			m_value;

public:
	SDEvent();
	virtual ~SDEvent(void);

	// Override in the derived class
	virtual SIMEVENTTYPE	getType()					{ return m_type; }
	virtual SDTime			getTime()					{ return m_time; }
	virtual string			getSource()					{ return m_source; }
	virtual string			getDestination()			{ return m_destination; }
	virtual string			getPost()					{ return m_port; }
	virtual double			getValue()					{ return m_value; }

	virtual void			log();

};