#include "source\includes.h"
#include "sd.h"

// Scene node state class
//**********************************
// A special value used to determine if a node has been rendered
/*static*/ unsigned int SDSceneNodeState::m_i = 0;

// SceneNodeInfo class
//*********************************

SDSceneNodeInfo::~SDSceneNodeInfo()
{
	// Delete the node object, since we own it
	if(m_pNode)
	{
		delete m_pNode;
		m_pNode = NULL;
	}
}

void SDSceneNodeInfo::removeTreeLocation(SDTreeNode* t)
{
	vector<SDTreeNode*>::iterator i;
	i = m_treeLocations.begin();
	while( i != m_treeLocations.end() )
	{
		if( ((SDTreeNode*)(*i)) == t)
		{
			::log("Removed tree location from Scene node info");
			m_treeLocations.erase(i);
			break;
		}
		i++;
	}
}


// Node list class
//********************************

SDNodeList::SDNodeList(void)
{
}

SDNodeList::~SDNodeList(void)
{
	// Delete all the nodes and the node info wrappers
	vector<SDSceneNodeInfo*>::iterator i;
	i = m_nodes.begin();
	int j = 0;
	while(i != m_nodes.end())
	{
		SDSceneNodeInfo* pNodeInfo = ((SDSceneNodeInfo*)(*i));
		if( pNodeInfo )
		{
			::log("Deleting scene node %d", j);
			delete	pNodeInfo;
		}

		j++;
		i++;
	}

}

int SDNodeList::addNode(SDSceneNode* pNode)
{
	if( pNode == NULL)
		return -1;

	// Create a node info wrapper for this node	
	SDSceneNodeInfo* pNodeInfo = new SDSceneNodeInfo();
	pNodeInfo->setNodeObject(pNode);
	m_nodes.push_back(pNodeInfo);
	int index = (int)m_nodes.size()-1;
	
	return index;
}

