#pragma once

// The defualt minimum node bounding box size is 10.0 units
#define OCTTREE_MINNODESIZE	800.0

class SDSceneNode;

class SDOctTreeNode : public SDTreeNode
{
protected:

	// A pointer to the parent node
	SDOctTreeNode * m_pParent;

	// The 8 octtree children nodes of the octtree
	SDOctTreeNode *	m_pChildren[8];

	// The 3d space this node represents
	SD3DBox			m_bounds;

	// Internal method to create a child bounding box
	void			calculateChildBox(Point* c, Point* d, int child);

public:
	SDOctTreeNode(SDNodeList* pList, SDOctTreeNode* pParent, SD3DBox bounds, int depth);
	virtual ~SDOctTreeNode(void);

	// Return the bounding box
	virtual SD3DBox* getBoundingBox()	{ return &m_bounds; }

	// Gets the type of the tree
	virtual TREETYPE getTreeType() { return OCTREE; }

	// called when a node moves position so the tree can update its location
	virtual void nodeMoved( int nodeIndex );

	// Adds a node to the tree.
	virtual bool addNode(int nodeIndex);

	// Adds a node to the tree. The split depth is the number of times and object may be split in the octtree
	virtual bool addNode(int nodeIndex, int splitDepth);

	// Removes a node from this tree
	virtual bool removeNode( int nodeIndex );	

};
