#include "sd.h"

SDSceneGraph::SDSceneGraph(SDNodeList* pList)
{

	// Set the node list
	m_pNodeList = pList;

	// Create the octtree for the scene graph	
	SD3DBox	b;
	Point c;
	Point d;	
	c.x = 0.0;
	c.y = 0.0;
	c.z = 0.0;
	d.x = 12800.0;
	d.y = 12800.0;
	d.z = 12800.0;
	b.set(c, d);
	m_pRootNode = new SDOctTreeNode(pList, NULL, b, 1);

}

SDSceneGraph::~SDSceneGraph(void)
{
	// The root node
	if( m_pRootNode )
	{
		delete m_pRootNode;
		m_pRootNode = NULL;
	}

	// Does not own the node list.. Do not delete it
	m_pNodeList = NULL;
}

void SDSceneGraph::addNode(int nodeIndex)
{
	if( m_pNodeList->getNodeInfo(nodeIndex) == NULL)
	{
		::log("Added an invalid nodeIndex to the scene graph. Perhaps node index is for a different node list");
		return;
	}

	// Add the node
	if( m_pRootNode->addNode(nodeIndex) )
	{
		::log("Node added successfully to Scene graph");
	}
	else
	{
		::log("Unable to add node to scene graph");
	}
}
