#include "source\includes.h"
#include "sd.h"

SDTime::SDTime(void)
{
	m_time = 0;
}

SDTime::~SDTime(void)
{
}

void SDTime::setTime(string time)
{
	// Format hours:minutes:seconds:milliseconds
	int hours, minutes, seconds, milliseconds;
	sscanf(time.c_str(), "%d:%d:%d:%d", &hours, &minutes, &seconds, &milliseconds);
	setTime(hours, minutes, seconds, milliseconds);
}

void SDTime::setTime(int hours, int minutes, int seconds, int milliseconds)
{
	m_time = (hours*60*60*1000) + (minutes*60*1000) + (seconds*1000) + milliseconds;
}

void SDTime::getTime(int *hours, int *minutes, int *seconds, int *milliseconds)
{
	double t = m_time;
	*hours = floor(t / (60*60*1000));
	t -= *hours * (60*60*1000);
	*minutes = floor(t / (60*1000));
	t -= *minutes * (60*1000);
	*seconds = floor(t / (1000));
	t -= *seconds * (1000);
	*milliseconds = t;
}

// Get the time in standard string from
string SDTime::getTimeString()
{	
	char buffer[255];
	int hours, minutes, seconds, milliseconds;
	getTime(&hours, &minutes, &seconds, &milliseconds);
	sprintf(buffer, "%02d:%02d:%02d:%03d", hours, minutes, seconds, milliseconds);
	return string(buffer);
}
