#include "source\includes.h"
#include "sd.h"

SDTreeNode::SDTreeNode(SDNodeList* pList, unsigned int depth)
{
	// Set the node list
	m_pNodes  = pList;

	// Create the node reference list
	m_pNodeRefList = new list<int>;

	// Set the depth
	m_depth = depth;
}

SDTreeNode::~SDTreeNode(void)
{
	// Delete the node reference list
	if( m_pNodeRefList )
	{
		// Remove the links to nodes in this tree
		list<int>::iterator i;
		i = m_pNodeRefList->begin();
		while(i != m_pNodeRefList->end())
		{
			SDSceneNodeInfo* pNodeInfo = m_pNodes->getNodeInfo(*i);
			if( pNodeInfo )
			{
				// Remove the link to this tree in the node
				pNodeInfo->removeTreeLocation(this);
			}
			i++;
		}

		// Delete the list
		delete m_pNodeRefList;
		m_pNodeRefList = NULL;

	}


}
