#include "sd.h"

/*static*/ SDVisualization*	SDVisualization::s_pVisualization = NULL;

SDVisualization::SDVisualization(void)
{
	// Create the time
	m_pTime = new SDTime();
	m_pTime->setTime(0.0);

	// Create the node list
	m_pNodeList	= new SDNodeList();

	// Create the scene graph
	m_pSceneGraph = new SDSceneGraph(m_pNodeList);

	// Create the model list
	m_pModelList = new SDDevsModelList();

	// Create the event list
	m_pEventList = new SDEventList();

}

SDVisualization::~SDVisualization(void)
{
	// Delete the time object
	if(m_pTime)
	{
		delete m_pTime;
		m_pTime = NULL;
	}

	// Delete the model list
	if( m_pModelList )
	{
		delete m_pModelList;
		m_pModelList = NULL;
	}

	// Delete the Event list
	if( m_pEventList )
	{
		delete m_pEventList;
		m_pEventList = NULL;
	}

	// Delete the scenegraph
	if( m_pSceneGraph )
	{
		delete m_pSceneGraph;
		m_pSceneGraph = NULL;
	}

	// Delete the node list
	if( m_pNodeList )
	{
		delete m_pNodeList;
		m_pNodeList = NULL;
	}

}

void SDVisualization::addNode(SDSceneNode* pNode)
{
	// Add the node to the node list
	int i = m_pNodeList->addNode(pNode);	
	::log("Adding node to node list at position %d", i);

	// Add the node to the scene graph
	m_pSceneGraph->addNode(i);

}