#pragma once

#include <string>
using namespace std;

#include "sdtime.h"

class SDSceneNode;
class SDNodeList;
class SDEventList;
class SDDevsModelList;
class SDSceneGraph;

class SDVisualization
{
protected:
	static SDVisualization*	s_pVisualization;

	// The list of DEVS objects possibly visualized in this simulation
	SDDevsModelList*	m_pModelList;

	// The list of actual visualization nodes
	SDNodeList*			m_pNodeList;

	// The scene graph heirarchy for the nodes
	SDSceneGraph*	m_pSceneGraph;

	// The list of events concerning the nodes
	SDEventList*	m_pEventList;

	// The current time the visualization state represents
	SDTime*			m_pTime;

	// The name of the visualization
	string			m_name;

	SDVisualization(void);
	virtual ~SDVisualization(void);
public:

	static SDVisualization* create()	{ if( !s_pVisualization) { s_pVisualization = new SDVisualization(); } return s_pVisualization; }
	static SDVisualization* get()		{ return s_pVisualization; }
	static void				destroy()	{ if( s_pVisualization) { delete s_pVisualization; s_pVisualization = NULL; } }

	void			setName(string name)		{ m_name = name; }
	string			getName()					{ return m_name; }

	SDTime			getTime()					{ return *m_pTime; }

	SDNodeList*			getNodeList()				{ return m_pNodeList; }
	SDEventList*		getEventList()				{ return m_pEventList; }
	SDDevsModelList*	getModelList()				{ return m_pModelList; }

	// Adds a node to the visualization
	void	addNode(SDSceneNode* pNode);

	// Add time adjusting methods

	// Add event methods


};
