#pragma once

// The token index for various information in an log file line
#define TOKEN_TYPE			1
#define TOKEN_TIME			2
#define TOKEN_SOURCE		3
#define TOKEN_PORT			4
#define TOKEN_VALUE			5
#define TOKEN_DESTINATION	7


#include <string>
#include <vector>
using namespace std;

class SDEvent;
class VCSimulationLink;
class SDDevsModel;

class SLLogFile : public SLBase
{
protected:
	// The log file this simulation link recieves its data from
	string m_logFile;

	// Parses a line from a log file to produce an event
	virtual bool parse(char* line);

	// Divides a string into tokens based on separators in the deliminator string
	void tokenize(vector<string>* tokens, string line, string delims); 

	// Sets the values for an model and an event based on tokens
	void createVisualizationObjects(SDDevsModel* msrc, SDDevsModel* mdest, SDEvent* e, vector<string>& tokens);

public:
	SLLogFile(VCSimulationLink* pLink, string logFile);
	virtual ~SLLogFile(void);

	// Loads the log file and imports the data into the visualization
	virtual bool connect();

};
