#pragma once
#include "fstream"
using namespace std;

#define MAX_READ_STRING_LENGTH 1024

enum SeekFrom {
	SeekBegining,
	SeekCurrent,
	SeekEnd
};

class BinaryFileStreamWriter {
public:
	BinaryFileStreamWriter(const char* filename);
	~BinaryFileStreamWriter(void);

	bool isBad() {return _stream.bad();}

	int seek(long position);
	int seek(long offset, SeekFrom from);

	void writeChar(char c);
	void writeString(char* string);
	void writeString(char* string, int length);
	void writeTag(char* tag) { writeString(tag, 3);	}

	void writeString(std::string string);

	void writeInteger(int number);
	void writeDouble(double number);
	void writeFloat(float number);
	void writeShort(short number);
	
	void close();
private:
	ofstream _stream;
	char* _filename;
};

class BinaryFileStreamReader {
public:
	BinaryFileStreamReader(const char* filename);
	~BinaryFileStreamReader(void);

	bool eof() {return _stream.eof();}
	bool isBad() {return _stream.bad();}

	int seek(long position);
	int seek(long offset, SeekFrom from);

	char readChar();
	int readString(string* pStr);
	bool readString(string* pStr, int length);
	bool readTag(string* pStr) {return readString(pStr, 3);}

	int readInteger();
	double readDouble();
	float readFloat();
	short readShort();

	void close();

private:
	ifstream _stream;
	char* _filename;
	char buffer[MAX_READ_STRING_LENGTH + 1];
};