#pragma once

class Game;
class Environment;

class DefaultUI :
	public UserInterface
{

private:
	Font *_font;
	Game *_game;
	FreeCamera *_camera;
	FollowCamera *_followCamera;
	bool _isDisposed;

	bool m_controlDown, m_altDown, m_shitDown;

	static const int screenWidth = 800;
	static const int screenHeight = 600;
	
public:
	DefaultUI(Game *game);
	virtual ~DefaultUI(void);

	bool processKeyDown(unsigned char key, int x, int y);
	bool processKeyUp(unsigned char key, int x, int y);
	bool processSpecialKeyDown(int key, int x, int y);
	bool processSpecialKeyUp(int key, int x, int y);
	
	bool processMouseMove(int x, int y);
	bool processMouseClick(int button, int state, int x, int y);
	

	void showCursor(bool show);

	void tick();
	void draw();

	void setupFonts();
	void cleanupFonts();

	void dispose();
};
