#pragma once

// Follows an ILocalObject
// Uses distance and a rotation to determin position
class FollowCamera :
	public ICamera
{
private:	
	// Follow camera state
	Point				m_currentPosition;	
	TargetOrientation	m_orientation;
	Transformation		m_cameraMatrix;
	
public:
	// Camera parameters
	IMoveable*		m_pTarget;
	double			m_viewDistance;
	double			m_leadDistance;
	double			m_maxSpeed;
	double			m_viewHeight;
	Point			m_up;

	FollowCamera(void);
	~FollowCamera(void);

	virtual void pushMatrix();
	virtual void popMatrix();

	virtual void moveBy(Point offset);
	virtual void moveBy(double x, double y, double z);

	virtual void moveTo(Point position);
	virtual void moveTo(double x, double y, double z);

	virtual void rotateBy(Point offset);
	virtual void rotateBy(double x, double y, double z);
	
	virtual void rotateTo(Point position);
	virtual void rotateTo(double x, double y, double z);	

	virtual void getPosition(Point *p) { *p = m_currentPosition; }
	virtual void getRotation(Point *r) { r->x = 0.0; r->y = 0.0; r->z = 0.0;}

	void tick();
	void draw();
	
	void setTarget(IMoveable* pTarget) { m_pTarget = pTarget; }
};
