#pragma once

#define FONT_RANGE_START 32
#define FONT_RANGE_END 128
#define FONT_RANGE_LENGTH 96

struct Point;

class Font {

//Private Instance Members
private:
	GLuint	m_fontBase;	
	Point	m_avgSize;
	bool	m_isDisposed;

// Instance Methods
public:
	Font(const char* fontName, int size, bool bold = false, bool italic = false);
	~Font(void) {
		if(!m_isDisposed)
		{
			glDeleteLists (m_fontBase, FONT_RANGE_LENGTH); //Delete all 96 characters
			m_isDisposed = true;
		}		
	};
	
	void drawText(int posX, int posY, const char* message,...);

	Point getAverageCharSize() {return m_avgSize;};

private:
	void initialize(const char* fontName, int size, bool bold, bool italic);
	void calculateAverageSize(HDC hdc);
};

DECLAREDICTIONARY(Font);