#pragma once
//#include "interfaces.h"

class FreeCamera :
	public ICamera
{

public:	
	DualTransformation cameraMatrix;
	Point position;
	Point rotation;

	bool translateLeft, translateRight, translateUp, translateDown;
	bool translateAhead, translateBack;
	bool rotateLeft, rotateRight, rotateUp, rotateDown;
	bool rollLeft, rollRight;

public:
	FreeCamera(void) {
		
		translateLeft = translateRight = translateUp = translateDown = false;
		translateAhead = translateBack = false;
		rotateLeft = rotateRight = rotateUp = rotateDown = false;
		rollLeft = rollRight = false;

		moveTo(0,0,0);
		rotateTo(0,0,0);
	};
	
	virtual ~FreeCamera(void) {};

	virtual void moveBy(Point offset);
	virtual void moveBy(double x, double y, double z);

	virtual void moveTo(Point position);
	virtual void moveTo(double x, double y, double z);

	virtual void rotateBy(Point offset);
	virtual void rotateBy(double x, double y, double z);
	
	virtual void rotateTo(Point position);
	virtual void rotateTo(double x, double y, double z);	
	
	virtual void getPosition(Point *p) { p->x = position.x; p->y = position.y; p->z = position.z; }
	virtual void getRotation(Point *r) { r->x = rotation.x; r->y = rotation.y; r->z = rotation.z; }

	virtual void draw();
	virtual void tick();

	virtual void pushMatrix() {
		glPushMatrixd(cameraMatrix) ;
	};
	virtual void popMatrix() {
		glPopMatrix();
	};

private:
	void updateMatrix();
};
