#include "includes.h"

void Jeep::tick() {
	
	const float driveSpeed = 10.0;
	const float turnSpeed = 90.0;
	
	double deltaTime = Timer::Get()->deltaTime;
	float frameDriveSpeed = driveSpeed * deltaTime;
	float frameTurnSpeed = turnSpeed * deltaTime;

	if (turnLeft)
		m_rotation.y += frameTurnSpeed * (driveBackward ? -1 : 1);
	if (turnRight)
		m_rotation.y -= frameTurnSpeed * (driveBackward ? -1 : 1);
	
	Transformation matrix;
	matrix.rotateBy(-m_rotation);
	
	if (driveForward) {
		m_position.x -= frameDriveSpeed * matrix.m13;
		m_position.y -= frameDriveSpeed * matrix.m23;
		m_position.z -= frameDriveSpeed * matrix.m33;
	}
	if (driveBackward) {
		m_position.x += frameDriveSpeed * matrix.m13;
		m_position.y += frameDriveSpeed * matrix.m23;
		m_position.z += frameDriveSpeed * matrix.m33;
	}
}

void Jeep::draw() {
	__super::draw();
}

void Jeep::processProperties() {
	char buffer[32];
	PropertyMapIterator iterator = m_properties.find("aoi");
	if (iterator != m_properties.end() ) {
		strcpy(buffer, iterator->second);
		sscanf(buffer, "%lf", &m_areaOfInfluence);
	}
}