#include "includes.h"

bool Mesh::serialize(BinaryFileStreamWriter *output) {
	output->writeTag(TAG_MESH);
	output->writeInteger( (int)m_faces.size());
	LOOPVECTOR(faceIndex, m_faces)
		Face *face = m_faces[faceIndex];
		face->serialize(output);
	ENDLOOP
	return true;
}
bool Mesh::deserialize(BinaryFileStreamReader *input) {
	string tag;
	input->readTag(&tag); //MSH
	int faceCount = input->readInteger();
	for(int faceIndex = 0; faceIndex < faceCount; faceIndex++) {
		Face *face = new Face;
		face->deserialize(input);
		m_faces.push_back(face);
	}
	return true;
}

void Mesh::addFaces(FaceCollection &faces) {
	//Copy into the the existing face collection.
	LOOPVECTOR (faceIndex, faces)
		Face *oldFace = faces [faceIndex];
		Face *newFace = new Face();
		
		newFace->texture = oldFace->texture;
		
		//Copy the point collection entries.
		LOOPVECTOR (pointIndex, oldFace->points)
			GamePoint *oldPoint = oldFace->points [pointIndex];
			GamePoint *newPoint = new GamePoint;
			*newPoint = *oldPoint; //Copy the data.
			newFace->points.push_back (newPoint);
		ENDLOOP
		m_faces.push_back (newFace);
	ENDLOOP
}

void Mesh::draw() {
	Face *face = NULL;
	LOOPVECTOR(faceIndex, m_faces)
		face = (Face*)m_faces[faceIndex];
		face->draw();
	ENDLOOP
}