#include "includes.h"

/*static*/ MeshList MeshList::s_meshList;

bool MeshList::serialize(BinaryFileStreamWriter *output) {
	output->writeTag(TAG_MESHLIST);
	output->writeInteger((int)m_meshes.size());

	LOOPVECTOR(meshIndex, m_meshes)
		Mesh *mesh = m_meshes[meshIndex];
		mesh->serialize(output);
	ENDLOOP
	return true;
}
bool MeshList::deserialize(BinaryFileStreamReader *input) {
	string tag;
	input->readTag(&tag); //GML
	
	int meshCount = input->readInteger();
	for(int meshIndex = 0; meshIndex < meshCount; meshIndex++) {
		Mesh *mesh = new Mesh();
		mesh->deserialize(input);
		m_meshes.push_back(mesh);
	}
	return true;
}

int MeshList::getIndex(char *name) {
	if( name == NULL || strlen(name) == 0) {
		return -1;
	}
	LOOPVECTOR(meshIndex, m_meshes)
		Mesh *mesh = m_meshes[meshIndex];
		if (strcmp(mesh->m_meshName, name) == 0) {
			return meshIndex;
		}
	ENDLOOP
	return -1;
}

int MeshList::addMesh(Mesh *mesh) {
	m_meshes.push_back(mesh);
	return (int)m_meshes.size() - 1;	
}