#include "includes.h"

Scrollbar::Scrollbar(void) {
	m_minValue = 1;
	m_maxValue = 10;
	m_currentValue = 1;
	
	m_callback = NULL;

	m_barBackColor.set(1,1,1,0.5);
	m_barForeColor.set(0,0,0,1);

	m_handleBackColor.set(1,1,1,1);
	m_handleForeColor.set(0,0,0,1);
}

Scrollbar::~Scrollbar(void)
{
}

bool Scrollbar::processSpecialKeyDown(int key, int x, int y) {
	return false;
}

void Scrollbar::tick() {
}

void Scrollbar::draw() {

	glDisable(GL_TEXTURE_2D);
	
	Transformation matrix;
	matrix.translateBy(m_position);
	glPushMatrix();
	glMultMatrixd(matrix);

	glEnable(GL_BLEND);
	
	m_barBackColor.apply();
	glBegin(GL_POLYGON);
		glVertex2d(0,0);
		glVertex2d(m_size.x, 0);
		glVertex2d(m_size.x, m_size.y);
		glVertex2d(0, m_size.y);
	glEnd();	

	glLineWidth(1);
	m_barForeColor.apply();
	glBegin(GL_LINE_LOOP);
		glVertex2d(0,0);
		glVertex2d(m_size.x, 0);
		glVertex2d(m_size.x, m_size.y);
		glVertex2d(0, m_size.y);
	glEnd();

	float range = m_maxValue - m_minValue;
	float percent, handleHeight, position;
	
	if (range == 0) {
		percent = 0;
		handleHeight = m_size.y - 4;
		position = 0;
	} else {
		percent = 1 - ((m_currentValue - m_minValue) / range);
		handleHeight = (m_size.y - 4) / (range + 1);
		if (handleHeight < 6) handleHeight = 6;
		position = percent * (m_size.y - handleHeight - 4);
	}
	
	m_handleBackColor.apply();
	glBegin(GL_POLYGON);
		glVertex2d(2, 2 + position);
		glVertex2d(m_size.x - 2, 2 + position);
		glVertex2d(m_size.x-2, handleHeight + 2 + position);
		glVertex2d(2, handleHeight + 2 + position);
	glEnd();

	m_handleForeColor.apply();
	glBegin(GL_LINE_LOOP);
		glVertex2d(2, 2 + position);
		glVertex2d(m_size.x - 2, 2 + position);
		glVertex2d(m_size.x-2, handleHeight + 2 + position);
		glVertex2d(2, handleHeight + 2 + position);
	glEnd();

	glPopMatrix();

	glColor3f(1,1,1);
	glDisable(GL_BLEND);
}
