#pragma once

//class Mesh;
struct RGBA {
	float r,g,b,a;
	void set(float r, float g, float b, float a) {
		this->r = r;
		this->g = g;
		this->b = b;
		this->a = a;
	};
	void apply() {
		glColor4f(r,g,b, a);
	};

	static RGBA Null;
};

class UIElement : public ITickable, IDrawable
{
protected:
	bool m_visible;
	Point m_position;
	Point m_size;
	UserInterface *m_parent;

public:
	void show() {
		if (!m_visible) {
			m_visible = true;
			onShow();
		}
	};
	void hide() {
		if(m_visible) {
			m_visible = false;
			onHide();
		}
	};
	void toggleVisible() {
		if (m_visible) 
			hide();
		else
			show();
	};
	bool getVisible() {return m_visible;};
	
	Point getPosition() {return m_position;};
	void setPosition(Point point) {m_position = point;};
	void setPosition(float x, float y) {m_position.x = x; m_position.y = y;};

	Point getSize() {return m_size;};
	void setSize(Point size) {m_size = size;};
	void setSize(float x, float y) {m_size.x = x; m_size.y = y;};

	UserInterface *getParent() {return m_parent;};
	void setParent(UserInterface *parent) {m_parent = parent;};
protected:
	virtual void onShow() = 0;
	virtual void onHide() = 0;
};
