#pragma once
class Game;

enum CAMERAMODE
{
	FREECAMERA,
	FOLLOWCAMERA
};

class WorldUI :
	public UserInterface
{
private:
	static const int screenWidth=800;
	static const int screenHeight=600;

	FreeCamera _freeCamera;
	FollowCamera _followCamera;

	Game *_game;
	ICamera *_camera;
	CAMERAMODE	_camMode;
	double _time;
	bool _cursorVisible;

	Font *_debugFont;
	Font *_smallFont;

	bool _isDisposed;
public:
	WorldUI(Game* game);

	~WorldUI(void) {
		if (!_isDisposed)
			dispose();
	};

	bool processKeyDown(unsigned char key, int x, int y);
	bool processKeyUp(unsigned char key, int x, int y);
	bool processSpecialKeyDown(int key, int x, int y);
	bool processSpecialKeyUp(int key, int x, int y);

	bool processMouseMove(int x, int y);
	bool processMouseClick(int button, int state, int x, int y);

	void showCursor(bool show);

	void tick();
	void draw();

	void setupFonts();
	void cleanupFonts();

	void dispose() {
		_isDisposed = true;
		cleanupFonts();
	};
};
