
//*****************************************************************************************//
//                                      Includes                                           //
//*****************************************************************************************//

#include "includes.h"

//*****************************************************************************************//
//                                        Faces                                            //
//*****************************************************************************************//

void Face::tick () {
	//This could change textures dynamically or change texture coordinates or do nothing.
}

void Face::draw () {
	//Draw this face... 

	texture->activate();
	
	//Permit blending if it's a texture with alpha...
	if (texture->type == RGBAType) {
		glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
		glEnable (GL_BLEND);
	} else {
		glDisable (GL_BLEND);
	}

	//Draw it.
	glBegin (GL_POLYGON);
		for (unsigned long pointIndex = 0; pointIndex < this->points.size(); pointIndex++) {
			GamePoint *point = points [pointIndex];
			glNormal3d (point->nx, point->ny, point->nz);
			glTexCoord2d (point->tx, point->ty);
			glVertex3d (point->x, point->y, point->z); //Must be last.
		}
	glEnd ();

}

bool Face::deserialize(BinaryFileStreamReader *input) {
	string tag;
	input->readTag(&tag);
	int textureID = input->readInteger();

	texture = TextureList::Get()->GetTexture(textureID);
	int pointCount = input->readInteger();
	
	for(int pointIndex = 0; pointIndex < pointCount; pointIndex++) {
		GamePoint *gmp = new GamePoint();
		gmp->deserialize(input);
		points.push_back(gmp);
	}
	return true;
}