//*****************************************************************************************//
//                                        Face                                             //
//*****************************************************************************************//

#ifndef faceModule
#define faceModule 

struct GamePoint {
	double x, y, z;
	double nx, ny, nz;
	double tx, ty;

	bool serialize(BinaryFileStreamWriter *output) {return false;}
	bool deserialize(BinaryFileStreamReader *input) {
		string tag;
		input->readTag(&tag);
		x = (double)input->readFloat();
		y = (double)input->readFloat();
		z = (double)input->readFloat();
		nx = (double)input->readFloat();
		ny = (double)input->readFloat();
		nz = (double)input->readFloat();
		tx = (double)input->readFloat();
		ty = (double)input->readFloat();
		
		return true;
	};	
};

DECLARECOLLECTION (GamePoint);

class Face : ISerializable {
public:
	//A face owns it points and texture name and therefore deletes them on its own.
	Plane plane;
	Texture *texture;
	GamePointCollection points;

	Face () {};
	Face (Plane &plane) {
		this->plane = plane; texture = NULL;
	}
	~Face () { deleteGamePointCollectionEntries (points); };

	void tick ();
	void draw ();

	bool serialize(BinaryFileStreamWriter *output) {return false;}
	bool deserialize(BinaryFileStreamReader *input);
};


DECLARECOLLECTION (Face);

#endif