
// Shader functions
#include "includes.h"

char *readShader (const char *filename) {
	//A file with suffix ".vsh" or ".psh".
	FILE *file = fopen (filename, "r"); if (file == NULL) return NULL;

	static char program_string [16384];
	unsigned int lengthRead = (unsigned int)fread (program_string, 1, 16384, file);
	program_string [lengthRead] = '\0';

	fclose (file);

	return program_string;
}

unsigned int loadShader (GLuint type, const char *filename) {
	//Reads and sets up a shader file and returns handle for later activation.
	char *program_string = readShader (filename);
	if (program_string == NULL) return 0;

	glEnable (type);
	unsigned int shaderNumber;
	GLExtensions::get()->glGenProgramsARB (1, &shaderNumber);
	GLExtensions::get()->glBindProgramARB (type, shaderNumber);
	GLExtensions::get()->glProgramStringARB (type, GL_PROGRAM_FORMAT_ASCII_ARB, (GLsizei)strlen (program_string), (const GLbyte *) program_string);
	glDisable (type);

	return shaderNumber;
}