//*****************************************************************************************//
//                                        World                                            //
//*****************************************************************************************//

#ifndef worldModule
#define worldModule 

DECLAREDICTIONARY (Texture);

class World {
public:
	WorldObjectCollection m_worldObjects;
	LocalObjectCollection m_localObjects;

	Point startPosition;
	Vector startRotation;

	World () {};
	~World () {
		deleteWorldObjectCollectionEntries (m_worldObjects); 
		deleteLocalObjectCollectionEntries (m_localObjects); 
	}

	static void setup ();
	static void wrapup ();

	void tick ();
	void draw ();

	static World *load (); //Prompts for a file name to read a ".wrl" file from and reads it into a new world.
	static World *load(const char* filename);
	void unload (); //Makes sure all textures are unloaded prior to deleting the world.
};

#endif