#include "sd.h"
#include "vc.h"

VCModelList::VCModelList(SDDevsModelList* pModelList)
{
	m_pModelList = pModelList;
}

VCModelList::~VCModelList()
{
	m_pModelList = NULL;
}

bool VCModelList::addModel(SDDevsModel* pModel)
{
	SDDevsModel* pSavedModel = m_pModelList->getModel(pModel->getName());
	if( pSavedModel )
	{
		// Add any new ports to the model
		if(pSavedModel->addPorts(pModel) > 0)
			pSavedModel->log();
	}
	else
	{
		// Add the new model
		return m_pModelList->addModel( pModel );
	}

	// Model not added
	return false;
}
