#pragma once

#include <string>
using namespace std;

// This class is the link to the Viewer display and interacts with it to complete the various maintenance tasks on a visualization
// ---

class SDVisualization;
class VCEventList;

class VCSimulation
{
protected:
	// global singleton simulation controller
	static VCSimulation* s_pSimulationControl;

	// Object to handle modifying the model list
	VCModelList*		m_pModelListControl;

	// Object to handle modifying the event list
	VCEventList*		m_pEventListControl;

	// The link to the current visualization
	SDVisualization*	m_pCurrentVisualization;

	VCSimulation(void);
	virtual ~VCSimulation(void);

public:

	static	VCSimulation*	create()	{ if( !s_pSimulationControl) s_pSimulationControl = new VCSimulation(); return s_pSimulationControl; }
	static	VCSimulation*	get()		{ return s_pSimulationControl; }
	static	void			destroy()	{ if( s_pSimulationControl) delete s_pSimulationControl; s_pSimulationControl = NULL; }

	bool	createNewVisualization( string name );
	void	closeVisualization();

	bool	importLogFile( string file );

};
