#pragma once

#define HISTORYSIZE	25

#include <list>
using namespace std;

class VDPanel;
class VDEditBox;
class VDTextBox;
class VDConsoleParser;

// A globally accessible terminal interfacing to the services of this program
// **************

class VDConsole : public VDPanel
{
protected:
	//Global console
	static VDConsole*	s_pConsole;

	// history of commands
	list<string>				m_history;
	list<string>::iterator		m_hisIndex;

	VDEditBox*	m_pEditBox;
	VDTextBox*	m_pTextBox;

	VDConsoleParser*	m_pConsoleParser;

	bool	m_visible;

	bool	m_controlsSetup;

public:
	VDConsole();
	virtual ~VDConsole(void);

	virtual void hide();
	virtual void show();
	virtual bool isVisible() { return m_visible; }

	virtual void printToConsole( string s );

	virtual void resizeControls(VDRectangleContainer<float>& newBounds);
	virtual void setupControls();
	virtual void setupControls(int maxLines);
	virtual bool processEvent(VDEvent *pEvent);

	//Global console methods
	static void			create() { s_pConsole = new VDConsole(); }
	static VDConsole*	get() { return s_pConsole; }
	static void			destroy() { if(s_pConsole) { delete s_pConsole; s_pConsole = NULL; } }

};
