#pragma once

// Template class for an arbitrary container
template <class T>
class VDContainer
{
public:
	VDContainer(void);
	virtual ~VDContainer(void);

	virtual bool containsPoint(T x, T y) = 0;
};

template <class T>
class VDRectangleContainer : public VDContainer<T>
{
protected:
	T m_x1;
	T m_x2;
	T m_y1;
	T m_y2;

public:
	VDRectangleContainer(void);
	virtual ~VDRectangleContainer(void);

	virtual void	setX1(T x1)						{ m_x1 = x1; }
	virtual void	setY1(T y1)						{ m_y1 = y1; }
	virtual void	setX2(T x2)						{ m_x2 = x2; }
	virtual void	setY2(T y2)						{ m_y2 = y2; }

	virtual T		getX1()							{ return m_x1; }
	virtual T		getY1()							{ return m_y1; }
	virtual T		getX2()							{ return m_x2; }
	virtual T		getY2()							{ return m_y2; }

	virtual T		getWidth()						{ return m_x2 - m_x1; }
	virtual T		getHeight()						{ return m_y2 - m_y1; }
	virtual void	setBounds(T x1, T y1, T x2, T y2);
	virtual bool	containsPoint(T x, T y);

	virtual void	translate(T x, T y)				{ m_x1 += x; m_x2 += x; m_y1 += y; m_y2 += y; }

	virtual void	setGLVertex2i()					
	{ 
		glVertex2i((int)m_x1, (int)m_y1);
		glVertex2i((int)m_x2, (int)m_y1);
		glVertex2i((int)m_x2, (int)m_y2);
		glVertex2i((int)m_x1, (int)m_y2);
	}

	virtual void	setGLVertex2f()
	{ 
		glVertex2f((float)m_x1, (float)m_y1);
		glVertex2f((float)m_x2, (float)m_y1);
		glVertex2f((float)m_x2, (float)m_y2);
		glVertex2f((float)m_x1, (float)m_y2);
	}
};
