#pragma once

class VDEvent;
class VDWindow;

class VDEditBox : public VDLabel
{
protected:
	int		m_caretPos;

	// For selecting text
	bool	m_allowSelect;

	bool	m_isSelecting;
	int		m_selectionPos;

	int		m_maxCharacters;

public:
	VDEditBox(void);
	virtual ~VDEditBox(void);

	void	setMaxLength( int characters )	{ m_maxCharacters = characters; }

	void	setTextSelect(bool on)			{ m_allowSelect = on; }
	void	setId( WINDOWID id)				{ m_id = id; }

	int		getMaxCharacters()	{ return m_maxCharacters; }
	int		getCaretPosition()	{ return m_caretPos; }
	int		getSelectPosition()	{ return m_selectionPos; }

	virtual void	setContents(string contents)	{ m_contents = contents; m_caretPos = 0; m_isSelecting = false; m_selectionPos = -1; }
	void			setCaretPosition(int i)	{ m_caretPos = i; if( i < 0) i = 0; if( i > (int)m_contents.length() ) i = (int)m_contents.length(); }


	virtual bool processEvent(VDEvent *pEvent);

};
