#pragma once

#include <vector>

using namespace std;

class VDEventListener;

// Base class for classes that generate events

class VDEventGenerator
{
private:
	// The bool indicates whether the event was gobbled by a window
	bool sendEventDown( VDEvent* pEvent);
	bool sendEventUp( VDEvent* pEvent);

protected:
	VDEventListener*		 m_pParentListener;
	vector<VDEventListener*> m_listeners;

	bool sendEventToWindow( VDEvent* pEvent, int i );
	bool sendEventToAll( VDEvent* pEvent);

public:
	VDEventGenerator(void);
	virtual ~VDEventGenerator(void);

	void unrequestEvents( VDEventListener* listener );	
	void requestEventsUp( VDEventListener* listener );
	void requestEventsDown( VDEventListener* listener );

};
