#pragma once

// Main window singleton class

#define MAINWINDOW	0
#define TESTEDITBOX 1

class VDConsole;
class VDMessageBoxCallBack;

class VDMainWindow : public VDWindow, public VDMessageBoxCallBack
{
protected:

	static VDMainWindow*	s_pMainWindow;
	VDMainWindow(int gridX, int gridY);
	virtual ~VDMainWindow(void);

	// Grid size for the main window
	// All subwindows base their location of this grid size
	int m_gridSizeX;
	int	m_gridSizeY;

	// Message box functionality
	VDMessageBox*			m_pMessageBox;
	
	// The object that is interested in the results of the current message box
	VDMessageBoxCallBack*	m_pMessageBoxCallBack;

	// Custom window
	VDWindow*				m_pCustomWindow;

public:	
	static VDMainWindow*	create(int width, int height)	{ if( s_pMainWindow == NULL ) { s_pMainWindow = new VDMainWindow(width, height); } return s_pMainWindow; }
	static VDMainWindow*	get()		{ return s_pMainWindow; }
	static void				destroy()	{ delete s_pMainWindow; }

	void setRootWindow( VDWindow* pWindow ) { if(pWindow) m_pCustomWindow = pWindow; }

	virtual bool sendEvent(VDEvent* pEvent);
	virtual bool processEvent(VDEvent *pEvent);

	virtual void resizeControls(VDRectangleContainer<float> bounds);
	virtual void setupControls();

	virtual void messageBox(MESSAGEBOXTYPE type, string message, VDMessageBoxCallBack* pCallBack);
	virtual void messageBoxResponse(MESSAGEBOXRESPONSE r);

};
