#include "vd.h"

VDMessageBox::VDMessageBox(MESSAGEBOXTYPE type, string message, VDMessageBoxCallBack* pCallBack)
{
	m_type = type;
	m_message = message;
	m_pCallBack = pCallBack;

	m_yesId		= 0;
	m_noId		= 1;
	m_okId		= 2;
	m_cancelId	= 3;

	m_resizable = false;
	m_moveable	= false;

}

VDMessageBox::~VDMessageBox(void)
{
}

void VDMessageBox::setupControls()
{
	// Create the label
	m_pMessage = new VDLabel();
	m_pMessage->setContents(m_message);
	VDRectangleContainer<float>	bounds;
	bounds.setBounds(m_bounds.getX1() + 2, m_bounds.getY2() - 22, m_bounds.getX2() - 2, m_bounds.getY2() - 2);
	m_pMessage->resizeControls(bounds);
	addChildWindow(m_pMessage);

	// Create the buttons
	if( m_type == YESNO )
	{
		VDTextButton* pButton = new VDTextButton();
		pButton->setText("Yes");
		pButton->setParentWindow(this);
		m_focusWindow = addChildWindow(pButton);
		pButton->setFocus(true);
		bounds.setBounds(m_bounds.getX1() + 120, m_bounds.getY1() + 15, m_bounds.getX1() + 190, m_bounds.getY1() + 35);
		pButton->resizeControls(bounds);
		pButton->setID(m_yesId);

		pButton = new VDTextButton();
		pButton->setText("No");
		pButton->setParentWindow(this);
		addChildWindow(pButton);
		bounds.setBounds(m_bounds.getX1() + 210, m_bounds.getY1() + 15, m_bounds.getX1() + 280, m_bounds.getY1() + 35);
		pButton->resizeControls(bounds);
		pButton->setID(m_noId);
	}
	else if( m_type == OKCANCEL )
	{
		VDTextButton* pButton = new VDTextButton();
		pButton->setText("Ok");
		pButton->setParentWindow(this);
		m_focusWindow = addChildWindow(pButton);
		pButton->setFocus(true);
		bounds.setBounds(m_bounds.getX1() + 20, m_bounds.getY1() + 10, m_bounds.getX1() + 60, m_bounds.getY1() + 30);		
		pButton->resizeControls(bounds);
		pButton->setID(m_okId);

		pButton = new VDTextButton();
		pButton->setText("Cancel");
		pButton->setParentWindow(this);
		addChildWindow(pButton);
		bounds.setBounds(m_bounds.getX1() + 80, m_bounds.getY1() + 10, m_bounds.getX1() + 120, m_bounds.getY1() + 30);
		pButton->resizeControls(bounds);
		pButton->setID(m_cancelId);
	}
	else if( m_type == YESNOCANCEL )
	{
		VDTextButton* pButton = new VDTextButton();
		pButton->setText("Yes");
		pButton->setParentWindow(this);
		m_focusWindow = addChildWindow(pButton);
		pButton->setFocus(true);
		bounds.setBounds(m_bounds.getX1() + 10, m_bounds.getY1() + 10, m_bounds.getX1() + 40, m_bounds.getY1() + 30);		
		pButton->resizeControls(bounds);
		pButton->setID(m_yesId);

		pButton = new VDTextButton();
		pButton->setText("No");
		pButton->setParentWindow(this);
		addChildWindow(pButton);
		bounds.setBounds(m_bounds.getX1() + 50, m_bounds.getY1() + 10, m_bounds.getX1() + 80, m_bounds.getY1() + 30);
		pButton->resizeControls(bounds);
		pButton->setID(m_noId);

		pButton = new VDTextButton();
		pButton->setText("Cancel");
		pButton->setParentWindow(this);
		addChildWindow(pButton);
		bounds.setBounds(m_bounds.getX1() + 90, m_bounds.getY1() + 10, m_bounds.getX1() + 120, m_bounds.getY1() + 30);		
		pButton->resizeControls(bounds);
		pButton->setID(m_cancelId);

	}

}

bool VDMessageBox::processEvent(VDEvent* pEvent)
{
	// Check for button presses
	if( pEvent->getType() == BUTTONPRESS )
	{
		VDButtonPressEvent* pButton = dynamic_cast<VDButtonPressEvent*>(pEvent);
		if( pButton->getWindowId() == m_yesId)
			m_pCallBack->messageBoxResponse(YES);
		else if( pButton->getWindowId() == m_noId )
			m_pCallBack->messageBoxResponse(NO);
		else if( pButton->getWindowId() == m_okId )
			m_pCallBack->messageBoxResponse(OK);
		else if( pButton->getWindowId() == m_cancelId )
			m_pCallBack->messageBoxResponse(CANCEL);

		// Add this object to the garbage can
		VDGarbageCan::get()->dispose(this);

		return true;
	}

	if(__super::processEvent(pEvent))
		return true;

	return sendEvent(pEvent);
}