#pragma once

enum MESSAGEBOXRESPONSE
{
	YES,
	OK,
	NO,
	CANCEL
};

enum MESSAGEBOXTYPE
{
	YESNO,
	OKCANCEL,
	YESNOCANCEL
};

class VDLabel;
class VDTextButton;

class VDMessageBoxCallBack
{
public:
	virtual void messageBoxResponse(MESSAGEBOXRESPONSE r) = 0;
};

class VDMessageBox :
	public VDPanel, public VDDisposable
{
protected:
	// Button ids
	WINDOWID			m_yesId;
	WINDOWID			m_noId;
	WINDOWID			m_okId;
	WINDOWID			m_cancelId;

	string				m_message;
	VDLabel*			m_pMessage;
	MESSAGEBOXTYPE		m_type;

	MESSAGEBOXRESPONSE		m_response;
	VDMessageBoxCallBack*	m_pCallBack;

public:
	VDMessageBox(MESSAGEBOXTYPE type, string message, VDMessageBoxCallBack* pCallBack);
	virtual ~VDMessageBox(void);

	virtual void setupControls();
	virtual bool processEvent(VDEvent* pEvent);

};
