#pragma once

enum SCROLLBARDIRECTION
{
	VERTICAL,
	HORIZONTAL
};

class VDWindow;

class VDScrollBar : public VDWindow
{
protected:
	int		m_sliderPos;
	int		m_sliderMax;

	// Memory position
	float	m_memPos;	
	int		m_memsliderPos;

	SCROLLBARDIRECTION	m_direction;

	// The size of the slider in the direction of the scroll bar
	float	m_sliderSize;

	// Are we scrolling
	bool	m_isScrolling;

	// Reset the slide size
	void	updateSlideSize();

public:
	VDScrollBar();
	virtual ~VDScrollBar();

	void	getSliderBounds(VDRectangleContainer<float>* bounds);

	int		getScrollPos()			{ return m_sliderPos; }
	int		getScrollMax()			{ return m_sliderMax; }
	float	getScrollFraction()		{ return (float)m_sliderPos/(float)m_sliderMax; }

	void	setDirection(SCROLLBARDIRECTION dir)	{ m_direction = dir; }
	void	setScrollPos(int pos);
	void	setScrollMax(int max)					{ m_sliderMax = max; updateSlideSize(); }

	virtual bool processEvent(VDEvent* pEvent);

	virtual void resizeControls(VDRectangleContainer<float>& bounds);
};