#pragma once

class VDScrollBar;

class VDTextBox : public VDWindow
{
protected:
	// Whether this text box can be edited
	bool	m_editable;

	// Whether this text box has a vertical scroll
	bool	m_vscroll;

	// The current line this text box is scrolled to
	int		m_currentLine;

	// List of lines for this text box
	VDStringLog	m_text;

	// The vertical scroll bar for this text box
	VDScrollBar*	m_pVScrollBar;
	float			m_vscrollWidth;

public:
	VDTextBox(bool vscroll);
	virtual ~VDTextBox(void);

	void			setVScrollWidth(float width)	{ m_vscrollWidth = width; }
	virtual int		getCurrentLine()				{ return m_currentLine; }
	virtual void	setNumberOfLines( int num)		{ m_text.setMaxSize(num); }
	virtual void	setCurrentLine(int line);

	virtual VDStringLog*	getText()						{ return &m_text; }
	float					getVScrollWidth()				{ return m_vscrollWidth; }

	virtual void	printLine( string line );
	virtual void	setupControls();
	virtual bool	processEvent(VDEvent* pEvent);
	virtual void	resizeControls( VDRectangleContainer<float>& newBounds );

};
