#pragma once

class VDKey;
class VDEditBox;
class VDLabel;
class VDTextBox;
class VDTextButton;
class VDPanel;
class VDScrollBar;

enum DRAWTYPE
{
	STATIC,		// doesn't require an immediate redisplay
	DYNAMIC     // requires an immediate redisplay
};

class VDTheme
{
protected:
	DRAWTYPE	m_draw;
public:
	VDTheme(void);
	virtual ~VDTheme(void);

	// Load resources in this function
	virtual void setup() = 0;
	// Delete resources in this function
	virtual void wrapup() = 0;

	virtual int		 getNumberOfLines( VDTextBox* pTextBox ) = 0;

	virtual void	 beginThemeDrawing(float width, float height) = 0;
	virtual DRAWTYPE endThemeDrawing() = 0;	

	virtual void drawLabel( VDLabel* pLabel );
	virtual void drawTextBox( VDTextBox* pTextBox );
	virtual void drawEditBox( VDEditBox *pEditBox );
	virtual void drawPanel(	VDPanel* pPanel);
	virtual void drawScrollBar(	VDScrollBar* pScrollBar);
	virtual void drawTextButton( VDTextButton* pTextButton);
	virtual void drawMainWindowBackground();

	virtual DRAWTYPE drawLabelImp( VDLabel* pLabel )				= 0;
	virtual DRAWTYPE drawTextBoxImp( VDTextBox* pTextBox )			= 0;
	virtual DRAWTYPE drawEditBoxImp( VDEditBox *pEditBox )			= 0;
	virtual DRAWTYPE drawPanelImp( VDPanel* pPanel)					= 0;
	virtual DRAWTYPE drawScrollBarImp( VDScrollBar* pScrollBar)		= 0;
	virtual DRAWTYPE drawTextButtonImp( VDTextButton* pTextButton)	= 0;
	virtual DRAWTYPE drawMainWindowBackgroundImp()					= 0;	

	// User interface commands config
	virtual bool isCutKey(VDKey* key)				= 0;
	virtual bool isCopyKey(VDKey* key)				= 0;
	virtual bool isPasteKey(VDKey* key)				= 0;
	virtual bool isFocusButton(int button)			= 0;
	virtual bool isFocusIncKey(VDKey* key)			= 0;
	virtual bool isFocusDecKey(VDKey* key)			= 0;
	virtual bool isResizeButton(int button)			= 0;
	virtual bool isMoveButton(int button)			= 0;
	virtual bool isScrollButton(int button)			= 0;
	virtual bool isScrollDown(VDKey* key)			= 0;
};
