#include "source\includes.h"
#include "source\enginevariables.h"
#include "vd.h"

/*static*/ VDThemeStore* VDThemeStore::s_pThemeStore = NULL;

VDThemeStore::VDThemeStore(void)
{
	// Set the current theme
	m_currentTheme = DEFAULTTHEME;

	// Create a default theme variable in the engine variables
	EngineVariables::get()->setVariable(std::string(CURRENTTHEME), std::string(DEFAULTTHEME));

	// Create the default theme and add it to the theme store
	VDDefaultTheme* pDefaultTheme = new VDDefaultTheme();
	pDefaultTheme->setup();

	// Add the default theme into the theme store associated with the DEFAULTTHEME string
	addTheme(std::string(DEFAULTTHEME), pDefaultTheme);
	
}

VDThemeStore::~VDThemeStore(void)
{
	// Delete the themes allocated
	VDThemeMapIterator i;
	for(i = m_themes.begin(); i != m_themes.end(); i++)
	{
		((VDTheme*)i->second)->wrapup();
		delete (VDTheme*)i->second;
	}

}

void VDThemeStore::addTheme( string name, VDTheme* pTheme )
{
	VDThemeMapIterator i = m_themes.find( name );
	if( i != m_themes.end() )
	{
		// Log an error
		return;
	}
	else
	{
		m_themes.insert(VDThemeMapPair(name, pTheme));
		pTheme->setup();
	}
}


