#pragma once

#include <map>
using namespace std;

class VDTheme;

typedef map<string, VDTheme*> VDThemeMap;
typedef VDThemeMap::iterator VDThemeMapIterator;
typedef pair <string, VDTheme*> VDThemeMapPair;

// The current theme environment variable
#define CURRENTTHEME "current_theme"

class VDThemeStore
{
protected:
	static VDThemeStore*	s_pThemeStore;

	VDThemeMap	m_themes;
	string		m_currentTheme;

	VDThemeStore(void);
	virtual ~VDThemeStore(void);

public:

	static bool				create()	{ s_pThemeStore = new VDThemeStore(); return (s_pThemeStore != NULL);}
	static void				destroy()	{ delete s_pThemeStore; s_pThemeStore = NULL; }
	static VDThemeStore*	get()		{ return s_pThemeStore; }

	void		setCurrentTheme(string currentTheme)		{ if( m_themes.find( currentTheme ) == m_themes.end() ) { m_currentTheme = currentTheme;	} }
	VDTheme*	getCurrentTheme()							{ return m_themes[m_currentTheme];	}
	void		addTheme( string name, VDTheme* pTheme );

};
